=== debian/changelog ===
openblas (0.3.31+ds-3) unstable; urgency=medium

  * Upload to unstable

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 13 Feb 2026 15:01:49 +0100

openblas (0.3.31+ds-2) experimental; urgency=medium

  * ftbfs-serial-arm64.patch: new patch taken from upstream.
    Fixes FTBFS on arm64.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 05 Feb 2026 18:35:53 +0100

openblas (0.3.31+ds-1) experimental; urgency=medium

  [ Sébastien Villemot ]
  * New upstream version 0.3.31+ds
  * d/copyright: reflect upstream changes
  * armhf-cpuid-asm.patch: drop patch, applied upstream
  * ppc64el-gcc-15.patch: drop patch, workaround no longer needed
  * loong64-dpotrf.patch: new patch taken from upstream.
    Fixes incorrect result of dpotrf on loong64 when using the la464 kernel.
    (Closes: #1126103)
  * ftbfs-serial.patch: new patch taken from upstream.
    Fixes FTBFS in serial flavour of the library.
  * d/t/upstream-testsuite{,64}: minor adjustment for linking to libopenblas
  * Drop versioned Build-Depends on debhelper.
    No longer needed, the constraint is satisfied in oldoldstable.
  * d/rules: use buildopts.mk to parse DEB_BUILD_OPTIONS
  * Drop “Priority: optional”, which is now the default
  * Bump Standards-Version to 4.7.3
  * Drop obsolete Breaks relationships (version constraints satisfied in
    oldoldstable)
  * d/copyright: update Upstream-Contact
  * d/upstream/metadata: update Changelog and Donation

  [ Alexandre Detiste ]
  * fix team name

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 04 Feb 2026 09:57:25 +0100
